unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Unit2, ScktComp, Sockets;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;

    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);

    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocket1ClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerSocket1ClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);

  private
    lab:array[0..11,0..9] of TNLabel;
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form1: TForm1;

  i:boolean;
  pcx,pcy:integer;


implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  x,y:integer;
begin
 for x:=0 to 11 do
  for y:=0 to 9 do begin
  lab[x,y]:=TNLabel.vytvor(x,y,Form1);
  lab[x,y].Parent:=Form1;
  Unit2.mnozina[x,y]:=lab[x,y];
  end;
  Unit2.SS1:=ServerSocket1;
  Unit2.CS1:=ClientSocket1;
  Unit2.L14:=Label14;
  Unit2.L15:=Label15;
  Unit2.L16:=Label16;
  Unit2.L17:=Label17;
  Unit2.L18:=Label18;
  Unit2.L19:=Label19;
  Unit2.L20:=Label20;
  Unit2.L21:=Label21;
  Unit2.L22:=Label22;
  Unit2.L23:=Label23;
  Unit2.L24:=Label24;
  Unit2.L25:=Label25;


end;


procedure TForm1.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  s:String;

begin
 Unit2.soc:=Socket;
 s:=Socket.ReceiveText;
  if s='prohra' then begin
   ShowMessage('Prohral jsi');
   Application.Terminate;
  end
  else if s='remiza2' then begin
   ShowMessage('Remiza, druhy hrac se nemuze pohybovat');
   Application.Terminate;
  end;
 if s[1]='B' then begin

    pcx:=ord(s[2])*10;
    pcx:=pcx + ord(s[3]);
    pcy:=ord(s[4])*10;
    pcy:=pcy + ord(s[5]);
    mnozina[pcx,pcy].Color:=clBlue;
   end
 else if s[1]='S' then
    mnozina[pcx,pcy].Color:=clOlive
 else begin
     if i then begin
      Unit2.TNLabel1.Prepsat(s);
      Label25.Caption:='Na tahu jsi ty';
      Unit2.t:=true;
      mnozina[pcx,pcy].Color:=clOlive;
    end
    else begin
    if (Unit2.znaS) then
       Socket.SendText(Unit2.pole);
    i:=true;
    Unit2.TNLabel1.Nastavit(s);
    Unit2.t:=true;
    Unit2.soc:=Socket;
    end;
 end;
end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var
  s:String;
begin
  s:=Socket.ReceiveText;
  if s='prohra' then begin
   ShowMessage('Prohral jsi');
   Application.Terminate;
  end
  else if s='remiza2' then begin
   ShowMessage('Remiza, druhy hrac se nemuze pohybovat');
   Application.Terminate;
  end ;
  if s[1]='B' then begin
    pcx:=ord(s[2])*10;
    pcx:=pcx + ord(s[3]);
    pcy:=ord(s[4])*10;
    pcy:=pcy + ord(s[5]);
    mnozina[pcx,pcy].Color:=clBlue;
   end
  else if s[1]='S' then
    mnozina[pcx,pcy].Color:=clOlive
  else begin
      if i then begin
       Unit2.TNLabel1.Prepsat(s);
       mnozina[pcx,pcy].Color:=clOlive;
       Label25.Caption:='Na tahu jsi ty';
       Unit2.t:=true;
      end
      else begin
       i:=true;
       Unit2.TNLabel1.Nastavit(s);
     end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);   // pusteni serveru
begin
  ServerSocket1.Port:=StrToInt(Edit1.Text);
  ShowMessage('Vytvoren server na portu '+Edit1.Text);
  ServerSocket1.Active:=true;
  Form1.Caption:='Marl - Server';
  Button2.Enabled:=False;
  Button1.Enabled:=False;
  Label25.Caption:='Hru zan ty';

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ClientSocket1.Port:=StrToInt(Edit1.Text);
  ClientSocket1.Address:=Edit2.Text;
  ClientSocket1.Active:=true;
  ShowMessage('Pripojeno k serveru '+Edit2.Text+':'+Edit1.Text);
  Unit2.soc:=ClientSocket1.Socket;
  Form1.Caption:='pin - Klient';
  Button2.Enabled:=False;
  Button1.Enabled:=False;
  Label25.Caption:='Hru zan protihr';
  end;

procedure TForm1.ServerSocket1ClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMessage('Pripojil se klient '+Socket.RemoteHost+'('+Socket.RemoteAddress+')');
end;

procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMessage('Klient se odpojil');
  Button2.Enabled:=True;
  Button1.Enabled:=True;
end;


procedure TForm1.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ShowMessage('Chyba pri komunikaci se serverem');
  Button2.Enabled:=True;
  Button1.Enabled:=True;
end;

procedure TForm1.ServerSocket1ClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ShowMessage('Chyba pri komunikaci s klientem');
  Button2.Enabled:=True;
  Button1.Enabled:=True;
end;


end.
