unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Math;

var
 s:String;
 u:integer;
 t,boj:boolean;
 zx:integer;
 zy:integer;

 znaK:boolean;
 znaS:boolean;

 CS1: TClientSocket;
 SS1: TServerSocket;
 soc: TCustomWinSocket;

L14:TLabel;
L15:TLabel;
L16:TLabel;
L17:TLabel;
L18:TLabel;
L19:TLabel;
L20:TLabel;
L21:TLabel;
L22:TLabel;
L23:TLabel;
L24:TLabel;
L25:TLabel;

 nfig:integer;      // celkovy pocet figur


 pole:String[120];
 barv:String[5];


type
 TNLabel = class(TLabel)
  constructor vytvor(x:integer; y:integer; AOwner: TForm);
  procedure FFOnClick(Sender: TObject);
  procedure Prepsat(poleA:String);
  procedure Nastavit(poleA:String);
  function KontrolaPruzk:boolean;
  function soused:boolean;
  private
  cx:integer;
  cy:integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
 TNLabel1: TNLabel;
 mnozina:array[0..11,0..9] of TNLabel;


implementation



constructor TNLabel.vytvor(x:integer; y:integer; AOwner: TForm);
begin
  inherited Create(AOwner);
  cx:=x;
  cy:=y;
  if ((x<8) and (x>=4) and ((y=2) or (y=3) or (y=6) or (y=7))) then
    Self.Color:=clMaroon
  else
  Self.Color:=clOlive;
  Self.Alignment:=taCenter;
  Self.Layout:=tlCenter;

  Self.OnClick:=Self.FFOnClick;

  Self.Top:=10+x*31;
  Self.Left:=10+y*31;
  Self.AutoSize:=False;
  Self.Width:=30;
  Self.Height:=30;

end;

procedure TNLabel.Prepsat(poleA:String);
var
  f:integer;
  h:boolean;
  fx:integer;
  fy:integer;
  nfn:integer; // aktualni pocet figur
begin
  h:=false;    // muze tahnout?
  nfn:=0;
  for f:=0 to 119 do begin
   fx:=f div 10;
   fy:=f mod 10;

   if (not h) and (ord(poleA[f+1])>127) and (ord(poleA[f+1])<>(128+ord('M')))
              and (ord(poleA[f+1])<>(128+ord('V')))  then begin // nebyl nalezen mozny tah...
    h:=h or ((fy>0) and (ord(poleA[f])<127)) or ((fy<9) and (ord(poleA[f+2])<127)) // vodorovny smer
         or ((fx>0) and (ord(poleA[f-9])<127)) or ((fx<11) and (ord(poleA[f+11])<127)) // svisly smer
         or ((fy>0) and (fx>0) and (ord(poleA[f-10])<127))      // doleva nahoru
         or ((fy>0) and (fx<11) and (ord(poleA[f+10])<127))     // doleva dolu
         or ((fy<9) and (fx>0) and (ord(poleA[f-8])<127))       // doprava nahoru
         or ((fy<9) and (fx<11) and (ord(poleA[f+12])<127));    // doprava dolu
   end;

   if (ord(poleA[f+1])>127) then begin
    mnozina[fx,fy].Caption:=chr(ord(poleA[f+1]) xor 128);
    pole[f+1]:=chr(ord(poleA[f+1]) xor 128);
    inc(nfn);
   end else
   if (ord(poleA[f+1])=32) then begin
    mnozina[fx,fy].Caption:='';
    pole[f+1]:=chr(32);
   end else begin
    mnozina[fx,fy].Caption:='x';
    pole[f+1]:=chr(ord(poleA[f+1]) xor 128);
    inc(nfn);
   end
  end;
  if not h then begin
   ShowMessage('Remiza, nemuzes se pohybovat');
   soc.SendText('remiza2');
   Application.Terminate;
  end;
  if nfn<>nfig then  begin
     nfig:=nfn;
     L14.Caption:='0';
     L15.Caption:='0';
     L16.Caption:='0';
     L17.Caption:='0';
     L18.Caption:='0';
     L19.Caption:='0';
     L20.Caption:='0';
     L21.Caption:='0';
     L22.Caption:='0';
     L23.Caption:='0';
     L24.Caption:='0';
     for f:=1 to 120 do
      case  chr(ord(pole [f]) xor 128)  of
       '9' : L14.Caption:=inttostr(strtoint(L14.Caption)+1);
       '8' : L15.Caption:=inttostr(strtoint(L15.Caption)+1);
       '7' : L16.Caption:=inttostr(strtoint(L16.Caption)+1);
       '6' : L17.Caption:=inttostr(strtoint(L17.Caption)+1);
       '5' : L18.Caption:=inttostr(strtoint(L18.Caption)+1);
       '4' : L19.Caption:=inttostr(strtoint(L19.Caption)+1);
       '3' : L20.Caption:=inttostr(strtoint(L20.Caption)+1);
       '2' : L21.Caption:=inttostr(strtoint(L21.Caption)+1);
       '1' : L22.Caption:=inttostr(strtoint(L22.Caption)+1);
       'M' : L23.Caption:=inttostr(strtoint(L23.Caption)+1);
       'V' : L24.Caption:=inttostr(strtoint(L24.Caption)+1);
      end;
  end;

end;

procedure TNLabel.Nastavit(poleA:String);
var
  f:integer;
begin
  nfig:=80;
  for f:=0 to 119 do begin
   if (ord(poleA[f+1])<>32) and (ord(poleA[f+1])<128) then begin
    mnozina[f div 10,f mod 10].Caption:='x';
    pole[f+1]:=chr(ord(poleA[f+1]) xor 128);
   end
  end;
end;

procedure TNLabel.FFOnClick(Sender: TObject);
var
 dx,dy:integer;
 cil,zdr:integer;
begin
  if (u<40) then begin
   if (SS1.Active) then begin
    if (Self.Caption='') and (Self.cx>=8) then begin
     u:=u+1;
     Self.Caption:=s[u];
     pole[cx*10+cy+1]:=s[u];
    end;
    if (u=40) then begin      // posledni + odeslou se data pres sit

     if not (soc=nil) then soc.SendText(pole);
     znaS:=true;
     zx:=-1;
    end;
    end
   else if (CS1.Active) then begin
    if (Self.Caption='') and (Self.cx<=3) then begin
     u:=u+1;
     Self.Caption:=s[u];
     pole[cx*10+cy+1]:=s[u];
    end;
    if (u=40) then begin      // posledni + odeslou se data pres sit
     if not (soc=nil) then soc.SendText(pole);
     zx:=-1;
    end
   end
   else begin
    ShowMessage('Nastavte klient nebo server')
    end;
    end
  else     // uz je to na tahy...
    if t then begin
     if (zx=-1) then begin
      if not ((Self.Caption='') or (Self.Caption='x') or (Self.Caption='V') or (Self.Caption='M')) then begin
       zx:=cx;
       zy:=cy;
       mnozina[cx,cy].Color:=clBlue;

       barv:='B' + chr(cx div 10) + chr(cx mod 10) +
             chr(cy div 10) + chr(cy mod 10);
       soc.SendText(barv);
      end;
      end
     else begin
      dx:=abs(cx-zx);
      dy:=abs(cy-zy);
      if (mnozina[cx,cy].Color=clOlive) and (dx+dy>0) and
        (mnozina[cx,cy].Caption='x') and            // cil je souper
        (dx+dy=1)
         then begin // utok na figuru

        cil:=ord(pole[cx*10+cy+1]) xor 128;
        zdr:=ord(pole[zx*10+zy+1]);

        mnozina[cx,cy].Caption:=chr(cil);
        mnozina[cx,cy].Repaint;
        sleep(3000);
        mnozina[cx,cy].Caption:='x';

        if (cil=ord('V')) then begin         // vlajka
          soc.SendText('prohra');
          ShowMessage('Gratuluji, sebral jsi vlajku!');
          Application.Terminate;
         end
        else
        if ((cil=ord('M')) and (zdr=ord('2')))    // narazil na minu, je miner   NEBO
          or
          ((cil=ord('9')) and (zdr=ord('1')))               // cil marsal, zdroj spion        NEBO
          or
          (
           (cil<zdr)    // cil je nizsi nez zdroj
           and not (
            ((cil=ord('1')) and (zdr=ord('9')))                        // A NENI cil spion,zdroj marsal
            or
            (cil=ord('M'))                                         // A cil neni mina
           )
          ) then begin
           pole[cx*10+cy+1]:=chr(32);
           case  cil  of
             ord ('9') : L14.Caption:=inttostr(strtoint(L14.Caption)-1);
             ord ('8') : L15.Caption:=inttostr(strtoint(L15.Caption)-1);
             ord ('7') : L16.Caption:=inttostr(strtoint(L16.Caption)-1);
             ord ('6') : L17.Caption:=inttostr(strtoint(L17.Caption)-1);
             ord ('5') : L18.Caption:=inttostr(strtoint(L18.Caption)-1);
             ord ('4') : L19.Caption:=inttostr(strtoint(L19.Caption)-1);
             ord ('3') : L20.Caption:=inttostr(strtoint(L20.Caption)-1);
             ord ('2') : L21.Caption:=inttostr(strtoint(L21.Caption)-1);
             ord ('1') : L22.Caption:=inttostr(strtoint(L22.Caption)-1);
             ord ('M') : L23.Caption:=inttostr(strtoint(L23.Caption)-1);
             ord ('V') : L24.Caption:=inttostr(strtoint(L24.Caption)-1);
           end;
           nfig:=nfig-1;
           mnozina[cx,cy].Caption:='';
         end
        else if (cil=zdr) then begin  // stejna hodnota
           pole[cx*10+cy+1]:=chr(32);                       // zemrou oba
           mnozina[cx,cy].Caption:='';
           pole[zx*10+zy+1]:=chr(32);
           mnozina[zx,zy].Caption:='';
           case  cil  of
             ord ('9') : L14.Caption:=inttostr(strtoint(L14.Caption)-1);
             ord ('8') : L15.Caption:=inttostr(strtoint(L15.Caption)-1);
             ord ('7') : L16.Caption:=inttostr(strtoint(L16.Caption)-1);
             ord ('6') : L17.Caption:=inttostr(strtoint(L17.Caption)-1);
             ord ('5') : L18.Caption:=inttostr(strtoint(L18.Caption)-1);
             ord ('4') : L19.Caption:=inttostr(strtoint(L19.Caption)-1);
             ord ('3') : L20.Caption:=inttostr(strtoint(L20.Caption)-1);
             ord ('2') : L21.Caption:=inttostr(strtoint(L21.Caption)-1);
             ord ('1') : L22.Caption:=inttostr(strtoint(L22.Caption)-1);
             ord ('M') : L23.Caption:=inttostr(strtoint(L23.Caption)-1);
             ord ('V') : L24.Caption:=inttostr(strtoint(L24.Caption)-1);
            end;
            nfig:=nfig-2;
        end
        else begin               // jinak utocici prohraje a cil zustava
           pole[zx*10+zy+1]:=chr(32);
           mnozina[zx,zy].Caption:='';

        end;
        boj:=false;
        mnozina[zx,zy].Color:=clOlive;

        if (SS1.Active) or (CS1.Active) then begin
         soc.SendText(pole);
         L25.Caption:='Na tahu je protihr';
        end;

        t:=false;
        end
      else
       if (mnozina[cx,cy].Color=clOlive) and (dx+dy>0) and
         (mnozina[cx,cy].Caption='') and (             // prazdne cilove pole
         ((dx<=1) and (dy<=1)) or                 // normalni figura nebo pruzkumnik
         KontrolaPruzk // pruzkumnik
         ) then begin // tah figurou
            if (boj) then begin
               mnozina[zx,zy].Color:=clOlive;
               t:=false;
               boj:=false;
               zx:=-1;
               if (SS1.Active) or (CS1.Active) then begin
                  soc.SendText(pole);
                  L25.Caption:='Na tahu je protihr';

               end;
            end
            else begin
              pole[cx*10+cy+1]:=pole[zx*10+zy+1];
              mnozina[cx,cy].Caption:=mnozina[zx,zy].Caption;
              pole[zx*10+zy+1]:=chr(32);
              mnozina[zx,zy].Caption:='';
              mnozina[zx,zy].Color:=clOlive;
              mnozina[cx,cy].Color:=clBlue;
              zx:=cx;
              zy:=cy;
              if soused then boj:=true
              else begin mnozina[zx,zy].Color:=clOlive;
               t:=false;
               boj:=false;
               zx:=-1;
               if (SS1.Active) or (CS1.Active) then begin
                  soc.SendText(pole);
                  L25.Caption:='Na tahu je protihr';

               end;
               end;
            end;
       end
      else begin       // zadny tah
      if (boj) then begin
        t:=false;
        boj:=false;
        if (SS1.Active) or (CS1.Active) then begin
          soc.SendText(pole);
          L25.Caption:='Na tahu je protihr';
          end;
        end;
      mnozina[zx,zy].Color:=clOlive;
      barv:='S';
      soc.SendText(barv);
      zx:=-1;
      end;
end;
end;
end;

function TNLabel.KontrolaPruzk:boolean;
var                        
 dx,dy,f:integer;
 b:boolean;
begin
 dx:=abs(cx-zx);
 dy:=abs(cy-zy);

 b:=true;

 if (mnozina[zx,zy].Caption='3') and not boj then begin
  if (dx=0) then
   for f:=min(cy,zy)+1 to max(cy,zy)-1 do
    b:=b and (pole[cx*10+f+1]=chr(32))
  else if (dy=0) then
   for f:=min(cx,zx)+1 to max(cx,zx)-1 do
    b:=b and (pole[f*10+cy+1]=chr(32))
  else
   b:=false
  end
 else
  b:=false;

 KontrolaPruzk:=b;
end;

function TNLabel.soused:boolean;
var
 so:boolean;
begin
 so:=false;

 if (zx>0) and (mnozina[zx-1,zy].Caption='x') then
          so:=true;
 if (zx<11) and (mnozina[zx+1,zy].Caption='x') then
          so:=true;
 if (zy<9) and (mnozina[zx,zy+1].Caption='x') then
          so:=true;
 if (zy>0) and (mnozina[zx,zy-1].Caption='x') then
          so:=true;

 soused:=so;
end;

var
hh:integer;

begin
  SetLength(pole,120);
  for hh:=1 to 120 do begin
   pole[hh]:=' ';
   end;
  s:='VMMMMMMMM1222222333333334444455556667789';
  znaK:=false;
  znaS:=false;
  t:=false;

end.



